% I-THOP  (A first-order theorem prover based on PTTP technology)
% 
%      version 1.01
%      July 2, 1997
%      Copyright (C) 1997, Koji Iwanuma (iwanuma@esi.yamanashi.ac.jp)
% 
% This program is free software; you can redistribute it or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either versions 1, or (at your option)
% any later version.
%  
% This program is distributed in the hope that it will be useful but
% WITHOUT ANY WARRANTY.  See the GNU General Public License for more
% details.
% ---------------
%
%   install.pl 
%
% ---------------

load_ithop :-
 	load([
	   call_c,
           comMODE,
           comPRE,
	   comCOM,
	   comLIB,
	   comSORT
	   ]).

execute_ithop :-
	load_ithop,
	%-----------
	% The below is for SICStus V3 #5
	%------------
	load_foreign_resource(check_tool),
	signal_init,
	nl,write('I-THOP Version 1.01'),nl,
	%
        (prolog_flag(compiling,_,fastcode) ->
             nl,write('Compiling mode: fastcode'),nl ;
	prolog_flag(compiling,_,compactcode) ->
             nl,write('Compiling mode: compactcode'),nl ;
	%true ->
             nl,write('Error in compiling mode in initial setting'),nl,nl
	),
	%
	prolog_flag(argv,Argv),
	(Argv = [] ->
	     assert(batch_flag(off)),
	     nl,write('Entered into Interactive Mode !!'),nl ;
         Argv = ['-s', SettingFile] ->
	     assert(batch_flag(off)),
	     consult(SettingFile),
	     nl,write('Entered into Interactive Mode !!'),nl ;
         Argv = [File] ->
	     assert(batch_flag(on)),
	     nl,write('Entered into Batch Mode !!'),nl,
	     see(File),
	     read(PTTP_formula),
	     assert(PTTP_formula),
	     seen,
	     prove_this_in_time_limit,
	     halt ;
         Argv = ['-s', SettingFile, File] ->
	     assert(batch_flag(on)),
	     nl,write('Entered into Batch Mode !!'),nl,
	     consult(SettingFile),
	     see(File),
	     read(PTTP_formula),
	     assert(PTTP_formula),
	     seen,
	     prove_this_in_time_limit,
	     halt ;
	 %true ->
	     nl,
	     write('Usage: i-thop [-s StartFile]        #interactive mode'),nl,
	     write('       i-thop [-s StartFile] PTTP_File   #batch mode'),nl,
	     halt
	).

check :-
	load_ithop,
	%-----------
	% The below is for SICStus V3 #3 or its older.
	%
	%load_foreign_files(['check_tool.o'],[]),
	%------------
	load_foreign_resource(check_tool),
	signal_init,
	load(['../tptp_Solaris.ql']),
	assert(batch_flag(off)).

:- execute_ithop.
